/* Dodecahedron */

#include <stereocalls.h>

void dodecahedron()
{
#define G 1.61803398875
#define H 0.61803398875

point p[20] = { {1,1, 1}, {-1,1, 1}, {1,-1, 1}, {-1,-1, 1},
                {1,1,-1}, {-1,1,-1}, {1,-1,-1}, {-1,-1,-1},
                {0,G,H},  {0,-G,H},  {0,G,-H},  {0,-G,-H},
                {H,0,G},  {H,0,-G},  {-H,0,G},  {-H,0,-G},
                {G,H,0},  {-G,H,0},  {G,-H,0},  {-G,-H,0} };

void face(int a, int b, int c, int d, int e)
{
   mesh(p,a,b,c); mesh(p,a,c,d); mesh(p,a,d,e);
}

   face(0,12,14,1,8);
   face(2,12,14,3,9);
   face(2,12,0,16,18);
   face(1,14,3,19,17);
   face(4,16,18,6,13);
   face(0,16,4,10,8);
   face(2,18,6,11,9);
   face(3,9,11,7,19);
   face(1,8,10,5,17);
   face(5,17,19,7,15);
   face(6,11,7,15,13);
   face(4,10,5,15,13);
}

void process()
{
   init_graphic_window(720, 720, DIRECT);
   set_range('x', -3.0, 3.0);
   set_range('y', -3.0, 3.0);
   set_range('z', -2.0, 2.0);
   
   rotation_angles(30,25,12); 

   rotation_angles(30,25,12); 
   scale(0.7);
   translation(-0.6,0,0);
   build(dodecahedron);
   
   set_grey_levels();   
}
