/* Trefoil knot */

#include <stereocalls.h>

double saw(double x)
{
   int n;
   
   if (x<0) x = -x;
   n = (int)x;
   x = x-n;
   if (n&1)
      return x;
   else
      return 1-x;
}

void process()
{
   int x, y, width, height, r, g, b;
   int B;
   double A;
   double t;
   width = 110;
   height = 720;

   init_graphic_window(width, height, DIRECT);
   
   for (x=0; x<width; x++) {
       t = sin(2.0 * PI * x / (double)width);
       for (y=0; y<height; y++) {
           B = 20 + (int)(110*saw(x*0.14))+(int)(110*saw(y*0.14));
           A = 0.96*(256-B);
           r = 80;
           g = A*saw(0.9*t-0.05*y+0.3) + random()%B;
           b = A*saw(1.1*t+0.04*y+0.7) + random()%B;
           put_pixel(x, y, r, g, b);
       }
   }
   
   set_color_levels();
}


